#
#   PSC-GW.PSC.EDU GATED  initialization file:
#
#
# Act as a RIP gateway (announce 0.0.0.0 with metric 1)
# Act as a HELLO gateway (announce 10.0.0.0 with time delay 100 ms.)
# Do EGP
#
RIP gateway 1
EGP yes
HELLO gateway 100

autonomoussystem 2		# DCN/NSF

egpneighbor	10.7.0.63	# bbnnet2-arpanet-gw (BBN2)
egpneighbor	10.2.0.37	# purdue-cs-gw	- Core EGP
egpneighbor	10.3.0.27	# ISI-gateway	- Core EGP

egpmaxacquire	3

# Local nets and interfaces to announce, including default
#
announce 0            intf all proto rip			# DEFAULT
announce 128.182      intf all proto rip hello egp egpmetric 0	# PSC
announce 10.0.0.0     intf all proto rip hello			# ARPANET
#
# Other nets that we will announce to the ARPANET
#	NOTE that these are *NOT* static routes.
#
#	These sites will use us as a Primary ARPA gateway.  Mostly
#	NSFnet backbone sites and JvNC consortium members.
#
#	added 8/20/87 <fedor>
announce 128.209      intf all proto rip hello egp egpmetric 0	# NYNEX
announce 128.193      intf all proto rip hello egp egpmetric 0	# OREGON ST.
announce 129.25       intf all proto rip hello egp egpmetric 0	# DREXEL
announce 129.32       intf all proto rip hello egp egpmetric 0	# TEMPLE
announce 128.180      intf all proto rip hello egp egpmetric 0	# LEHIGH
announce 128.248      intf all proto rip hello egp egpmetric 0	# UI @ CHICAGO
announce 192.26.148   intf all proto rip hello egp egpmetric 0	# UMDNJ
#	added 7/21/87 <fedor>
announce 128.228      intf all proto rip hello egp egpmetric 0	# CUNY
#	added 6/26/87 <fedor>
announce 128.238      intf all proto rip hello egp egpmetric 0	# POLY-U-NET
announce 192.31.28    intf all proto rip hello egp egpmetric 0	# STEWARD-OBS
announce 192.31.89    intf all proto rip hello egp egpmetric 0	# MIAMI
#	added 6/9/87 <gmc>
announce 128.213      intf all proto rip hello egp egpmetric 0	# RPICSNET
#
#	changed or added 6/1/87 <fedor>
announce 128.135      intf all proto rip hello egp egpmetric 0	# U-Chicago
announce 128.111      intf all proto rip hello egp egpmetric 0	# UCSB
announce 192.12.15    intf all proto rip hello egp egpmetric 0	# BNL
announce 128.128      intf all proto rip hello egp egpmetric 0	# WHOINET
announce 128.148      intf all proto rip hello egp egpmetric 0	# BROWN UNIV.
announce 128.118      intf all proto rip hello egp egpmetric 0	# PENN-STATE
announce 192.5.156    intf all proto rip hello egp egpmetric 0	# PENN-STATE-6
announce 128.196      intf all proto rip hello egp egpmetric 0	# U-ARIZONA
announce 128.138      intf all proto rip hello egp egpmetric 0	# COLORADO
announce 192.12.103   intf all proto rip hello egp egpmetric 0	# CSU-ETHER
#	added 5/20/87 <gmc>
announce 128.226      intf all proto rip hello egp egpmetric 0	# BINGHAMTON
announce 128.230      intf all proto rip hello egp egpmetric 0	# SYR-UNIV-NET
#	added 5/11/87 <gmc>
announce 128.205      intf all proto rip hello egp egpmetric 0	# UBUFFALONET
#
#	added 5/1/87 <gmc>
announce 128.204      intf all proto rip hello egp egpmetric 0	# ALBNYNET
announce 128.153      intf all proto rip hello egp egpmetric 0	# CLARKSON
#	added 4/1/87 <gmc>
#
announce 128.235      intf all proto rip hello egp egpmetric 0	# NJIT
announce 192.31.3     intf all proto rip hello egp egpmetric 0	# ALCOA-NET
#  added 4/9/87 <gmc>
announce 128.174      intf all proto rip hello egp egpmetric 0	# UIUC      
#
announce 192.12.207   intf all proto rip hello egp egpmetric 0	# SDSC
announce 128.151      intf all proto rip hello egp egpmetric 0	# ROCHESTER
announce 35           intf all proto rip hello egp egpmetric 0	# MERIT
announce 128.112      intf all proto rip hello egp egpmetric 0	# PRINCETON
announce 128.116      intf all proto rip hello egp egpmetric 0	# USAN
announce 128.117      intf all proto rip hello egp egpmetric 0	# NCAR
announce 128.121      intf all proto rip hello egp egpmetric 0	# JVNC-NET
announce 192.12.216   intf all proto rip hello egp egpmetric 0	# STEVENS-TECH
announce 192.12.211   intf all proto rip hello egp egpmetric 0	# JVNC
#
#	These sites will use us as a backup ARPA gateway.
#
#	changed or added 7/21/87 <fedor>
announce 128.186      intf all proto rip hello egp egpmetric 3  # FSU
announce 192.26.27    intf all proto rip hello egp egpmetric 3  # ROCKEFELLER
announce 192.5.214    intf all proto rip hello egp egpmetric 3  # DECUACNET
#	changed or added 6/26/87 <fedor>
announce 128.163      intf all proto rip hello egp egpmetric 3  # UKY
announce 192.5.21     intf all proto rip hello egp egpmetric 3  # BRL-NET1
announce 128.63       intf all proto rip hello egp egpmetric 3  # BRL-SUBNET
announce 128.183      intf all proto rip hello egp egpmetric 3  # GSFC
announce 128.61       intf all proto rip hello egp egpmetric 3  # GATECH
announce 192.5.57     intf all proto rip hello egp egpmetric 3  # UDEL-CC
#	changed 6/1/87 <fedor>
announce 128.5        intf all proto rip egp egpmetric 3	# FORDNET
#	added 5/1/87 <gmc>
announce 128.164      intf all proto rip hello egp egpmetric 3 	# GWU
announce 128.109      intf all proto rip hello egp egpmetric 3 	# TUCC
announce 128.150      intf all proto rip hello egp egpmetric 3 	# NSF
announce 128.167      intf all proto rip hello egp egpmetric 3  # SURA
announce 128.169      intf all proto rip hello egp egpmetric 3 	# TENN
announce 128.173      intf all proto rip hello egp egpmetric 3 	# VaTECH
announce 192.5.219    intf all proto rip hello egp egpmetric 3 	# CLEMSON
announce 192.16.177   intf all proto rip hello egp egpmetric 3  # ALABAMA
announce 128.84       intf all proto rip hello egp egpmetric 3	# CORNELL-NET
announce 128.6        intf all proto rip hello egp egpmetric 3	# RUTGERS
announce 128.103      intf all proto rip hello egp egpmetric 3	# HARVARD
announce 128.104      intf all proto rip hello egp egpmetric 3	# U. WISCONSIN
announce 128.8        intf all proto rip hello egp egpmetric 3	# U. MARYLAND
announce 128.145      intf all proto rip hello egp egpmetric 3	# NYSERnet
announce 18           intf all proto rip hello egp egpmetric 3	# MIT
announce 192.12.82    intf all proto rip hello egp egpmetric 3	# COLUMBIA
announce 128.91       intf all proto rip hello egp egpmetric 3	# U. PENN
announce 192.12.220   intf all proto rip hello egp egpmetric 3	# U. WISCONSIN
announce 192.12.221   intf all proto rip hello egp egpmetric 3	# U. WISCONSIN
announce 128.113      intf all proto rip hello egp egpmetric 3	# RPINET
announce 128.122      intf all proto rip hello egp egpmetric 3	# NYU-NET
announce 128.59       intf all proto rip hello egp egpmetric 3	# COLUMBIA
announce 192.5.8      intf all proto rip hello egp egpmetric 3	# MACOMNET

# default gateway *IF* we lose our EGP neighbors.... we wil use NSF fuzzball
#
defaultgateway 128.182.1.2 hello active
